/*****************************************************************************
    cache.h

    Diese Datei ist Teil des Programmpakets 'ACL-tftp'.
    Alle Rechte bei Andreas G. Schindler
                    Klappacher Str. 2i
                    64285 Darmstadt, Deutschland.

    Dieses Programm ist 'Freie Software'; Sie knnen es entsprechend den 
    Bedingungen der 'Allgemeinen ffentlichen GNU-Lizenz' (verffentlicht 
    durch die 'Free Software Foundation') weiter verbreiten und/oder 
    modifizieren. Massgeblich ist die Version 2 oder eine neuere Version
    dieser Lizenz. 

    Dieses Programm wird in der Hoffnung dass es ntzlich is weitergegeben,
    jedoch OHNE JEDE GARANTIE. Dieser Garantieauschluss bezieht sich auch
    auf Eigenschaften wie Marktfhigkeit oder Eignung zu einem bestimmten
    Zweck. Details finden sich in der 'Allgemeinen ffentlichen GNU-Lizenz'.

    Eine Kopie dieser Lizenz sollte in  Programmpaket, dem diese Datei
    entstammt, enthalten sein. Falls nicht, schreiben Sie an die 
    'Free Software Foundation, Inc.', 59 Temple Place, Suite 330, Boston, 
    MA  02111-1307  USA.


    This file is part of the 'ACL-tftp' Package
    Copyright (C) 1999-2003 by Andreas G. Schindler
                               Klappacher Str. 2i
                               Darmstadt, Germany.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************************************************/
#ifndef CACHE_H
#define CACHE_H
#include "patstr.h"

#define CAC_BINARY	0x01
#define CAC_NETASCII	0x02
#define CAC_PRELOAD	0x04
#define CAC_UPDATE	0x08
#define CAC_NOAGE	0x10
#define CAC_RECURSIVE	0x20
#define CAC_VERIFY	0x40
#define CAC_VALID	0x1000	

#define CAC_MODE	(CAC_BINARY|CAC_NETASCII)
#define CAC_PROP	(CAC_PRELOAD|CAC_UPDATE|CAC_NOAGE|CAC_RECURSIVE|CAC_VERIFY|CAC_VALID)

#ifdef CPROPLIST

static patlist_t cproplist[] = { { "binary"   , CAC_BINARY    , CAC_NETASCII },
                                 { "ascii"    , CAC_NETASCII  , CAC_BINARY },
                                 { "preload"  , CAC_PRELOAD   , 0 },
                                 { "update"   , CAC_UPDATE    , 0 },
                                 { "noage"    , CAC_NOAGE     , 0 },
                                 { "verify"   , CAC_VERIFY    , 0 },
                                 { "recursive", CAC_RECURSIVE , 0 },
                                 { NULL       , 0             , 0 } };
#endif /* CPROPLIST */


int cacheLimits(ulong size, char *name);
int scanDir(char *dir, regex_t *compiled, int flag);
int addCacheObjs(void);
int preloadFile(void *entry);
int preloadCache(void);
int initCacheBuffer(void *vdc);
int getCacheBuffer(char *buf, int reqlen);
int loadCacheFile(char *file, int mode, void **vnew);

#endif /* CACHE_H */
